Bug 1313373 - nss-softokn 3.22 build uses nss as implicit dependency
nss-softokn 3.22 build uses nss as implicit dependency
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: nss-softokn (Show other bugs)
23
All Linux
unspecified Severity low
: ---
: ---
Assigned To: Kai Engert (:kaie)
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-03-01 08:50 EST by Zoltan Boszormenyi
Modified: 2016-12-20 14:09 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 14:09:38 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to avoid building and installing nss/cmd binaries (1.07 KB, patch)
2016-03-01 08:51 EST, Zoltan Boszormenyi
no flags Details | Diff

  None (edit)
Description Zoltan Boszormenyi 2016-03-01 08:50:00 EST
Description of problem:

Discovered during a build for OpenEmbedded which separates the host from the cross-compiled packages.

The problem is that nss-softokn 3.22 builds a few executables under nss/cmd:
bltest, fipstest, lowhashtest and shlibsign.
nss/cmd/manifest.mn somewhere after 3.19 moved these out of this protector:

ifndef NSS_BUILD_SOFTOKEN_ONLY
ifndef NSS_BUILD_UTIL_ONLY
...
endif
endif

and instead lists them under:

ifndef NSS_BUILD_UTIL_ONLY
...
endif

So these executables apparently build for both nss-softokn and nss.
However, nss (possibly an older version) is already installed via implicit dependencies.

For the OpenEmbedded build I get the errors below where NSS is definitely not installed since it is (1.) a new build from scratch, and (2.) I ported the nss-util/nss-softokn/nss split packages from Fedora with the same explicit dependency ordering (nss -> nss-softokn -> nss-util):

| /data/OE/setup-scripts/build/tmp-angstrom_v2014_06-eglibc/sysroots/x86_64-linux/usr/libexec/i586-sicom-linux/gcc/i586-sicom-linux/4.8.5/ld: error: cannot find -lssl3
| /data/OE/setup-scripts/build/tmp-angstrom_v2014_06-eglibc/sysroots/x86_64-linux/usr/libexec/i586-sicom-linux/gcc/i586-sicom-linux/4.8.5/ld: error: cannot find -lsmime3
| /data/OE/setup-scripts/build/tmp-angstrom_v2014_06-eglibc/sysroots/x86_64-linux/usr/libexec/i586-sicom-linux/gcc/i586-sicom-linux/4.8.5/ld: error: cannot find -lnss3
| collect2: error: ld returned 1 exit status
| make[2]: *** [Linux3.4_x86_glibc_PTH_OPT.OBJ/lowhashtest] Error 1
| make[2]: Leaving directory `/data/OE/setup-scripts/build/tmp-angstrom_v2014_06-eglibc/work/i586-sicom-linux/nss-softokn/3.22-r0/nss-softokn-3.22/nss/cmd/lowhashtest'

So, it is only a lucky accident that it builds for Fedora but I consider it cheating. In case some of these commands use a new feature from the current version that is to be build, the build would fail for Fedora.

Version-Release number of selected component (if applicable):

$ rpm -q nss-softokn
nss-softokn-3.22.0-1.0.fc23.x86_64
nss-softokn-3.22.0-1.0.fc23.i686

How reproducible:

Always.

Steps to Reproduce:
1.
2.
3.

Actual results:

nss-softokn implicitly uses nss as its build dependency so the build succeeds.
The runtime dependency (causing a dependency loop) is not there because
nss-softokn in Fedora doesn't ship the "lowhashtest" binary.

Expected results:

nss-softokn should not depend on nss.

Additional info:
Comment 1 Zoltan Boszormenyi 2016-03-01 08:51 EST
Created attachment 1131940 [details]
Patch to avoid building and installing nss/cmd binaries
Comment 2 Fedora Admin XMLRPC Client 2016-08-15 11:51:29 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 3 Fedora End Of Life 2016-11-24 10:52:09 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2016-12-20 14:09:38 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.